C-# --------------------------------------------------------------------------------------------------------
C-# ----- FLAE_ZUS (Einbauteil aus Zusatzprogramm)
C-# ----- Schraffiertes Polygon mit Aussparungsfunktion und Flaechenangabe, Typ(Text) defnierbar
C-# ----- Stand: 08/2012; Melzer
C-# Korrekturen:
C-# 01/2016: Damit die Mark.linie am ersten Punkt des Polygons endet musste "OBJEKT_ENDE...,0,0,0,POS" in
C-# "OBJEKT_ENDE...,X[1],Y[1],0,POS" gendert werden.
C-# ----------------------------------------------------------------------------------------------------------
TEXTVARIABLEN LEITEX,BEZTEX,DNAME,TYPTEX,SCHTEX,TEXTYP
TEXTVARIABLEN HILTEX01,HILTEX02,HILTEX11,HILTEX12,HILTEX13,HILTEX14

ZUWEISEN ISTEU,ELTYP
OBJEKT_TYP ELTYP


C-# ----------  Pos.Nr. zuweisen und initialisieren
ZUWEISEN_TEXT POS
OBJEKT_POS_INIT POS,VORH

C-# Felder indizieren
C-# max. 10 Polygone (1 Aussen-, 9 Innenpolygone); max. 200 Polygonpunkte insgesamt
C-# ADX=Anfangindex des Polygons; EDX=Endindex des Polygons; X/Y= Polygonpunkte; AP=Polygonflche
VAR_INIT ADX[1:10]=0
VAR_INIT EDX[1:10]=0
VAR_INIT X[1:200]=0
VAR_INIT Y[1:200]=0
VAR_INIT Y[1:200]=0
VAR_INIT AP[1:10]=0

C-# Voreinstellungen (flae_zus.vor) einlesen
AUFRUF VOREINLESEN

C-# Rcklschen aktivieren
STDFUNKTIONEN 'LINIEN',1,-1,-1,-1

C-# obere Leiste 
LEITEX='Polygone definieren:  Weitere Flaeche'
EINFUEGEN LEITEX
LEISTE LEITEX

C-# ----------  Polygon(e) definieren
C-# TF = Anzahl der Teilflaechen/Polygone
C-# Wird eine weitere (Teil-)Flaeche gewaehlt, wird der Endindex des vorherigen Polygons EDX[TF-1]=I-1 gesetzt, 
C-# Gleichzeitig wird der Anfangsindex fuer das neue Polygon ADX[TF]=I gesetzt.
C-# PNR = Polygon-Punktnummer, welche fr die Funktionsleiste als Anzeige verwendet wird.

HILTEX01='Flaeche'
HILTEX11='Punkt'
HILTEX12='anfahren'

TF;PNR=1
ADX[TF];EDX[TF]=1

SCHLEIFE I=1,200
	UMWANDELN TEXT 1,TF,HILTEX02
	UMWANDELN TEXT 1,PNR,HILTEX13
	HILTEX14=HILTEX02//'. '//HILTEX01//' | '//HILTEX11//' '//HILTEX13//' '//HILTEX12
	
	KOORDINATE X[I],Y[I],HILTEX14
		WENN NFUNKTA=110 UND I=1 STOP
		
	MARKE X[I],Y[I],0		
		
		WENN NFUNKTA>0 DANN
			WENN NFUNKTA=1 DANN
 				TF=TF+1
				EDX[TF-1]=I-1
				ADX[TF]=I
				I=I-1
				PNR=0
			SONST WENN NFUNKTA=111 DANN
				MARKE X[I-1],Y[I-1],-1
				PNR=PNR-2
				I=I-2
			SONST
				EDX[TF]=I-1
				XLOE=I
				GEHE END_POLYGON
			ENDE WENN
		ENDE WENN
	
	PNR=PNR+1
ENDE SCHLEIFE

:END_POLYGON
C-# Rcklschen deaktivieren
STDFUNKTIONEN 'LINIEN',-1,-1,-1,-1

C-# ----------  Polygonflaeche berechnen
AUFRUF FLAECHENBERECH

C-# ----------  Typ(Text) definieren und Schraffurparameter ber FZL whlen
AUFRUF TYPLEIZEI

C-# Markierungen lschen
SCHLEIFE I=1,XLOE
	MARKE X[I],Y[I],-1
ENDE SCHLEIFE

C-# ----------  Objekt erzeugen
AUFRUF OBJEKTERZEUGEN

STOP


C-# =========================================================================================
C-#                                   Unterprogramme
C-# =========================================================================================
UNTERPROGRAMM FLAECHENBERECH
C-# Flaechenberechnung; diese geht als Text in die EBT-, sowie die Abrechnungsliste
C-# TFLAE=Groee der einzelnen Teilflche in cm2, welche den Segmentfaktor beruecksichtigt
C-# LINDX;UINDX=Hilfsvariablen fr die Anfangs- u. Endindizes der Polygone zwischen zu speichern

A=0
LINDX;UINDX=0

SCHLEIFE K=1,TF
        LINDX=ADX[K]
	UINDX=EDX[K]
	
	TFLAE=0

	SCHLEIFE J=LINDX,UINDX-1
		TFLAE=TFLAE+0.5*(X[J]*Y[J+1]-X[J+1]*Y[J])
	ENDE SCHLEIFE

	TFLAE=TFLAE+0.5*(X[J]*Y[LINDX]-X[LINDX]*Y[J])

	F=TFLAE*SEGFAK*SEGFAK
	TFLAE=ABS(F)
	AP[K]=TFLAE
ENDE SCHLEIFE

C-# Anmerkung zu "F=TFLAE*SEGFAK*SEGFAK": Pro Koordinatenrichtung muss die Koordinate
C-# mal dem SEGFAK gesetzt werden, also die Flche wird aus X*Y gerechnet und daher muss
C-# der Flaechenwert nochmals mit (SEGFAK*SEGFAK) multipliziert werden!

C-# Gesamtflaeche = Aussenflaeche AP[1] - alle Innenflaechen AP[K]
C-# Bei TF=1 wird die Schleife automatisch nicht ausgewertet

SCHLEIFE K=2,TF
	AP[1]=AP[1]-AP[K]
ENDE SCHLEIFE

C-# Gesamtflche "A" (cm2)
A=AP[1]

RUECKSPRUNG


C-# =========================================================================================
UNTERPROGRAMM OBJEKTERZEUGEN

BEZTEX=TYPTEX//' A=%+A;m2%'

OBJEKT_POS_VERGL 1

OBJEKT_POSITION POS,'flae_zus',BEZTEX,1
OBJEKT_POSITION A

C-# ------------------------------- Objektanfang
OBJEKT_ANFANG EBTNUM

C-# Polygonlinien zeichnen
LINDX;UINDX=0

SCHLEIFE K=1,TF
        LINDX=ADX[K]
	UINDX=EDX[K]
	
	SCHLEIFE J=LINDX,UINDX-1
		LINIE X[J],Y[J],X[J+1],Y[J+1],1,9,IDIA,ILIN,EBTNUM,ELTYP
	ENDE SCHLEIFE
	
	LINIE X[LINDX],Y[LINDX],X[UINDX],Y[UINDX],1,9,IDIA,ILIN,EBTNUM,ELTYP
ENDE SCHLEIFE

C-# Schraffur zeichnen
AUFRUF SCHRAFFURERZEUGEN

C-# Text schreiben
TEXT XT,YT,1,TTYP,TSTINR,HTEXT,TWINK,4,TYPTEX,IDIA,ILIN,EBTNUM,ELTYP

C-# Zaehlfaktor abfragen
ZAEHLFAKTOR EBTZAEHL,2

C-# Positionsnummer ablegen
OBJEKT_POS_TEXT 0,0,5,0,0,0,0,'%POS%',0,EBTNUM,0,0,X[1],Y[1],0

OBJEKT_ENDE EBTNUM,EBTZAEHL,X[1],Y[1],0,POS
C-# ------------------------------- Objektende

RUECKSPRUNG


C-# =========================================================================================
UNTERPROGRAMM SCHRAFFURERZEUGEN
C-# NFL=-1  => zaehle Polygone selber; max. 10 Teilpolygone mglich
C-# Polygone werden ueber Felder schraffiert, 
C-# SCHRAFFUR Anfangsindex, Endindex, X-Array, Y-Array
C-# Wenn Anfang- und End-Index NULL ist wird die Anweisung ueberlesen

LEITEX='Polygon schraffieren:'
EINFUEGEN LEITEX
LEISTE LEITEX

NFL=-1

ABST=(SCHABST*ZEIMAS)/10

SCHRAFFUR SCHTYP,SCHSTINR,ABST,SCHWINK,1.1,0.5,NFL,0,ISCH,EBTNUM,ELTYP

SCHRAFFUR ADX[1],EDX[1],X,Y
SCHRAFFUR ADX[2],EDX[2],X,Y
SCHRAFFUR ADX[3],EDX[3],X,Y
SCHRAFFUR ADX[4],EDX[4],X,Y
SCHRAFFUR ADX[5],EDX[5],X,Y
SCHRAFFUR ADX[6],EDX[6],X,Y
SCHRAFFUR ADX[7],EDX[7],X,Y
SCHRAFFUR ADX[8],EDX[8],X,Y
SCHRAFFUR ADX[9],EDX[9],X,Y
SCHRAFFUR ADX[10],EDX[10],X,Y

RUECKSPRUNG


C-# =========================================================================================
UNTERPROGRAMM TYPLEIZEI

:MARK200

SCHTEX='bew.Betonu.Beton  MauerwerkBeton-FT StrichPktPunkt    Erde     NaSt     WU-Beton Bimsbeton'
S=SCHTYP*9

LEITEX=SCHTEX[S-8:S]//'S=#.##W=###Abstand=#.##'

EINFUEGEN LEITEX,SCHSTIST,SCHWINK,SCHABST
LEISTE LEITEX


TEXTEINGABE TYPTEX,'Objekttyp: ENTER=',TYPTEX

WENN NFUNKTA>0 DANN
    WENN NFUNKTA=1 DANN
        ABFRAGE SCHTYP,'Standardschraffur: bB  uB  Mau.  FT  stripu  punkt.  Erde  NaSt  wuB  bimsB '
    
    SONST WENN NFUNKTA=2 DANN
        STIFTNUMMER SCHSTINR
        
    SONST WENN NFUNKTA=3 DANN
        TEXTWINKEL SCHWINK,3
        
    SONST WENN NFUNKTA=4 DANN
        ZAHL SCHABST,'Schraffurabstand (mm): ENTER='
        ABST=(SCHABST*ZEIMAS)/10
        
    SONST WENN NFUNKTA=110 DANN
        AUFRUF VOREINSICHERN
        STOP
    ENDE WENN
    
    AUFRUF VOREINSICHERN
    HTEXT=HTEXT*ZEIMAS/10
    GEHE MARK200
ENDE WENN


:TEXTPLATZ

CFNTEXTY TTYP,TEXTYP
LEITEX='H=##.#S=#.##W=###'//TEXTYP

HT=HTEXT/ZEIMAS*10
EINFUEGEN LEITEX,HT,TSTIST,TWINK
LEISTE LEITEX

STEXTL HTEXT,TTYP,LT,1,TYPTEX

 
COSA=COS(TWINK)
SINA=SIN(TWINK)
 

AUFRUF FREILAPO


WENN NFUNKTA>0 DANN
    WENN NFUNKTA=1 DANN
        TEXTHOEHE HTEXT
        
    SONST WENN NFUNKTA=2 DANN
        STIFTNUMMER TSTINR
        
    SONST WENN NFUNKTA=3 DANN
        TEXTWINKEL TWINK,3
        
    SONST WENN NFUNKTA=4 DANN
        TEXTTYP TTYP
        
    SONST WENN NFUNKTA=110 DANN
        AUFRUF VOREINSICHERN
        STOP
    ENDE WENN
    
    AUFRUF VOREINSICHERN
    HTEXT=HTEXT*ZEIMAS/10
    GEHE TEXTPLATZ
ENDE WENN

RUECKSPRUNG


C-# =========================================================================================
UNTERPROGRAMM FREILAPO

DX=LT
DY=HTEXT
 
X0=0
Y0=0
X1=X0+DX*COSA
Y1=Y0+DX*SINA
X2=X1-DY*SINA
Y2=Y1+DY*COSA
X3=X2-DX*COSA
Y3=Y2-DX*SINA
 
ZIEPOL XT,YT,5,X0,Y0,X1,Y1,X2,Y2,X3,Y3,X0,Y0

RUECKSPRUNG


C-# =========================================================================================
UNTERPROGRAMM VOREINLESEN
C-# Schraffurabstand als Voreinstellung lesen

DNAME=VERZEBT//'flae_zus.vor'

DATEI 21,DNAME
LESEN 21,SCHTYP,SCHSTIST,SCHSTINR,SCHABST,SCHWINK
	WENN FEHLER=-1 DANN
        SCHTYP=1
        SCHSTIST=0.18
        SCHSTINR=1
        SCHABST=2
        SCHWINK=45
        TYPTEX='Heizbereich'
        HTEXT=3.5
        TSTIST=0.35
        TSTINR=3
        TWINK=0
        TTYP=1
        GEHE MARK100
    ENDE WENN
    
LESEN 21,TYPTEX
LESEN 21,HTEXT,TSTIST,TSTINR,TWINK,TTYP

:MARK100
SCHLIESSE 21

C-# Ist die Stiftnr. auf dem aktuellen Rechner belegt? Wenn nein, dann wird Stiftnr. "1"
C-# genommen und die zugehrige Stiftstrke ermittelt!
STIFTDICKE 1,STARK,SCHSTINR

WENN STARK=0.00 DANN
    SCHSTINR=1
    STIFTDICKE 1,SCHSTIST,SCHSTINR
SONST
    SCHSTIST=STARK
ENDE WENN

STIFTDICKE 1,STARK,TSTINR

WENN STARK=0.00 DANN
    TSTINR=1
    STIFTDICKE 1,TSTIST,TSTINR
SONST
    TSTIST=STARK
ENDE WENN


HTEXT=HTEXT*ZEIMAS/10

RUECKSPRUNG


C-# =========================================================================================
UNTERPROGRAMM VOREINSICHERN
C-# Schraffurabstand als Voreinstellung speichern

STIFTDICKE 1,SCHSTIST,SCHSTINR
STIFTDICKE 1,TSTIST,TSTINR

HTEXT=(HTEXT/ZEIMAS)*10


DNAME=VERZEBT//'flae_zus.vor'

DATEI 21,DNAME
SCHREIBEN 21,SCHTYP,SCHSTIST,SCHSTINR,SCHABST,SCHWINK
SCHREIBEN 21,TYPTEX
SCHREIBEN 21,HTEXT,TSTIST,TSTINR,TWINK,TTYP
SCHLIESSE 21

RUECKSPRUNG


C-# =========================================================================================
